// test user-level fault handler -- alloc pages to fix faults

#include <inc/lib.h>

void
handler(void* addr, uint32_t err)
{
	int r;

	printf("fault %x\n", addr);
	if ((r = sys_page_alloc(0, (void*) PTE_ADDR(addr), PTE_P|PTE_U|PTE_W)) < 0)
		panic("allocating at %x in page fault handler: %e", addr, r);
	snprintf((char*) addr, 100, "this string was faulted in at %x", addr);
}

void
umain(void)
{
	set_pgfault_handler(handler);
	printf("%s\n", (char*)0xDeadBeef);
	printf("%s\n", (char*)0xCafeBffe);
}
